#pragma once
#include "PPgGeneral.h"
#include "PPgConnection.h"
#include "PPgServer.h"
#include "PPgDirectories.h"
#include "PPgFiles.h"
#include "PPgStats.h"
#include "PPgNotify.h"
#include "PPgIRC.h"
#include "PPgTweaks.h"
#include "PPgDisplay.h"
#include "PPgSecurity.h"
#include "PPgWebServer.h"
#include "PPgScheduler.h"
#include "PPgProxy.h"
#if defined(_DEBUG) || defined(USE_DEBUG_DEVICE)
#include "PPgDebug.h"
#endif
#include "PPgVirtual.h"	// [TPT] - itsonlyme: virtualDirs
// [TPT]
#include "PPgMaella.h" // Maella -New setting panels => Tweaks II-
#include "PPgPhoenix.h"
#include "otherfunctions.h"
#include "ListBoxST.h"
#include "KCSideBannerWnd.h" 	//[TPT] - New Preferences Banner	
#include "ModeLess.h"

class CPreferencesDlg : public CModelessPropertySheet	// [TPT] - SLUGFILLER: modelessDialogs
{
	friend class CPreferencesPage; // [TPT] - SLUGFILLER: modelessDialogs

	DECLARE_DYNAMIC(CPreferencesDlg)
	
public:	
	
	CPreferencesDlg();
	virtual ~CPreferencesDlg();
	
	CPPgGeneral		m_wndGeneral;
	CPPgConnection	m_wndConnection;
	CPPgServer		m_wndServer;
	CPPgDirectories	m_wndDirectories;
	CPPgFiles		m_wndFiles;
	CPPgStats		m_wndStats;
	CPPgNotify		m_wndNotify;
	CPPgIRC			m_wndIRC;
	CPPgTweaks		m_wndTweaks;
	CPPgDisplay		m_wndDisplay;
	CPPgSecurity	m_wndSecurity;
	CPPgWebServer	m_wndWebServer;
	CPPgScheduler	m_wndScheduler;
	CPPgProxy		m_wndProxy;
#if defined(_DEBUG) || defined(USE_DEBUG_DEVICE)
	CPPgDebug		m_wndDebug;
#endif
	CPPgVirtual		m_wndVirtual;	// [TPT] - itsonlyme: virtualDirs
	// [TPT]
	CPPgMaella		m_wndMaella; // Maella -New setting panels => Tweaks II-
	CPPgPhoenix		m_wndPhoenix;

	CPreferences	*app_prefs;
	CListBoxST		m_listbox;
	CButton			m_groupbox;
	CImageList		ImageList;
	int				m_iPrevPage;

	void Localize();
	void SetPrefs(CPreferences* in_prefs)
	{
		app_prefs = in_prefs;
		m_wndGeneral.SetPrefs(in_prefs);
		m_wndDisplay.SetPrefs(in_prefs);
		m_wndConnection.SetPrefs(in_prefs);
		m_wndServer.SetPrefs(in_prefs);
		m_wndDirectories.SetPrefs(in_prefs);
		m_wndFiles.SetPrefs(in_prefs);
		m_wndStats.SetPrefs(in_prefs);
		m_wndNotify.SetPrefs(in_prefs);
		m_wndIRC.SetPrefs(in_prefs);
		m_wndTweaks.SetPrefs(in_prefs);
		m_wndSecurity.SetPrefs(in_prefs);
		m_wndWebServer.SetPrefs(in_prefs);
		m_wndScheduler.SetPrefs(in_prefs);
		m_wndProxy.SetPrefs(in_prefs);
		m_wndVirtual.SetPrefs(in_prefs);	// [TPT] - itsonlyme: virtualDirs
		m_wndPhoenix.SetPrefs(in_prefs); // [TPT]
#if defined(_DEBUG) || defined(USE_DEBUG_DEVICE)
		m_wndDebug.SetPrefs(in_prefs);
#endif
	}

protected:
	UINT m_nActiveWnd;

	virtual BOOL OnInitDialog();

	DECLARE_MESSAGE_MAP()
	afx_msg void OnDestroy();
	afx_msg void OnSelChanged();
	void UpdateSelection(CPropertyPage *page);	// [TPT] - SLUGFILLER: modelessDialogs
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
protected:
	CKCSideBannerWnd m_banner;	//[TPT] - New Preferences Banner	


};
