//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#pragma once
#include "loggable.h"
#include "OtherFunctions.h" // [TPT]

const CString strDefaultToolbar = _T("0099010203040506070899091011");

// DO NOT EDIT VALUES like making a uint16 to uint32, or insert any value. ONLY append new vars
#pragma pack(1)
struct Preferences_Ext_Struct{
	int8	version;
	uchar	userhash[16];
	WINDOWPLACEMENT EmuleWindowPlacement;
};
#pragma pack()

// deadlake PROXYSUPPORT
struct ProxySettings{
	uint16 type;
	uint16 port;
	char name[50];
	char user[50];
	char password[50];
	bool EnablePassword;
	bool UseProxy;
};

// [TPT] - khaos::categorymod+ View Filter Struct
#pragma pack(1)
struct CategoryViewFilter_Struct{
	//		General View Filters
	uint8	nFromCats;  // 0 == All; 1 == Unassigned; 2 == This Cat Only
	bool	bSuspendFilters;
	//		File Type View Filters
	bool	bVideo;
	bool	bAudio;
	bool	bArchives;
	bool	bImages;
	//		File State View Filters
	bool	bWaiting;
	bool	bTransferring;
	bool	bPaused;
	bool	bStopped;
	bool	bComplete;
	bool	bHashing;
	bool	bErrorUnknown;
	bool	bCompleting;
	//		File Size View Filters
	uint32	nFSizeMin;
	uint32	nFSizeMax;
	uint32	nRSizeMin;
	uint32	nRSizeMax;
	//		Time Remaining Filters
	uint32	nTimeRemainingMin;
	uint32	nTimeRemainingMax;
	//		Source Count Filters
	uint16	nSourceCountMin;
	uint16	nSourceCountMax;
	uint16	nAvailSourceCountMin;
	uint16	nAvailSourceCountMax;
	//		Advanced Filter Mask
	CString	sAdvancedFilterMask;
};
#pragma pack()

// Criteria Selection Struct
#pragma pack(1)
struct CategorySelectionCriteria_Struct{
	bool	bFileSize;
	bool	bAdvancedFilterMask;
};
#pragma pack()
// [TPT] - khaos::categorymod-

#pragma pack(1)
struct Category_Struct{
	char	incomingpath[MAX_PATH];
	char	title[64];
	char	comment[255];
	DWORD	color;
	uint8	prio;
	//CString autocat; // [TPT] - khaos::categorymod
	// [TPT] - khaos:kmod+ Category
	// View Filter Struct
	CategoryViewFilter_Struct viewfilters;
	CategorySelectionCriteria_Struct selectioncriteria;
	char	autoCat[255];
	// [TPT] - khaos:kmod-
};

#pragma pack()

#pragma pack(1)
struct Preferences_Struct{
	
	// Maella 
	float	maxupload;                    // [FAF] -Allow Bandwidth Settings in <1KB Incremements-
	float	maxdownload;
	float	maxGraphDownloadRate;
	float	maxGraphUploadRate;
	bool	disablexs;                    // -Enable/Disable source exchange in preference- (Tarod)
	bool	reaskSourceAfterIPChange;     // -Reask sources after IP change- (idea Xman)
	uint8	zoomFactor;                   // -Graph: display zoom-
	bool	enableCorruptionTest;         // -Defeat 0-filled Part Senders- (Idea of xrmb)
	bool	enableSkipCorruptionCDTest;   // -Defeat 0-filled Part Senders- (Idea of xrmb)
	bool	blockUploadEndMsg;            // -Filter verbose messages-
	bool	blockPhoenixMsg;			  // [TPT] - Filter own messages
	bool	blockHandshakeMsg;			  // [TPT] - Filter Handshake messages
	
	
	
	bool    blockFilteredIPSourceMsg; 
	bool    blockFilteredIPServerMsg;
	bool    blockMaellaSpecificMsg;
	bool    blockMaellaSpecificDebugMsg;
	bool	compensateOverhead;           // -Overhead compensation (pseudo full rate control)-
	uint16	MTU;                          // -MTU Configuration-
	uint16	minUploadSlot;                // -Minimum Upload Slot-
	uint16	sendSocketBufferSize;         // -New bandwidth control-
	bool	NAFCEnable;					  // -Network Adapter Feedback Control-
	bool	NAFCFullControl;	          // -Network Adapter Feedback Control-
	float	NAFCNetworkOut;	              // -Network Adapter Feedback Control-
	uint8	datarateSamples;              // -Accurate measure of bandwidth: eDonkey data + control, network adapter-	
	bool    enableMultiQueue;             // -One-queue-per-file- (idea bloodymad)
	bool    enableReleaseMultiQueue;
	bool    enableNewUSS;
	uchar   A4AFFileId[16];               // -Auto A4AF-
	bool    enableA4AFTransfer;
	// Maella end
	
	int m_iCreditSystem; // [TPT] - Credit System

	//eWombat [SNAFU][TPT]
	bool m_bSnafu;
	bool m_bAntiCreditTheft;
	bool m_bAntiFriendshare;

	char	nick[255];
	// ZZ:UploadSpeedSense -->
    //uint16  minupload;
	// ZZ:UploadSpeedSense <--
	//uint16	maxupload;
	//uint16	maxdownload;
	uint16	port;
	// [TPT] - TBH: minimule
	bool	m_bMiniMule;
	uint32	m_iMiniMuleUpdate;
	bool	m_bMiniMuleLives;
	int8	m_iMiniMuleTransparency;
	// [TPT] - TBH: minimule
	uint16	udpport;
	uint16	nServerUDPPort;
	uint16	kadudpport;
	uint16	maxconnections;
	int8	reconnect;
	int8	deadserver;
	int8	scorsystem;
	char	incomingdir[MAX_PATH];
	char	tempdir[MAX_PATH];
	int8	ICH;
	int8	autoserverlist;
	int8	updatenotify;
	int8	mintotray;
	int8	autoconnect;
	int8	autoconnectstaticonly; // Barry
	int8	autotakeed2klinks;     // Barry
	int8	addnewfilespaused;     // Barry
	int8	depth3D;			   // Barry
	int		m_iStraightWindowStyles;
	TCHAR	m_szSkinProfile[MAX_PATH];
	TCHAR	m_szSkinProfileDir[MAX_PATH];
	int8	addserversfromserver;
	int8	addserversfromclient;
	int16	maxsourceperfile;
	int16	trafficOMeterInterval;
	int16	statsInterval;
	uchar	userhash[16];
	WINDOWPLACEMENT EmuleWindowPlacement;
	//int		maxGraphDownloadRate;
	//int		maxGraphUploadRate;
	uint8	beepOnError;
	uint8	confirmExit;
	// [TPT] - IP Country +1
	// [TPT] - khaos::categorymod+ +2
	int16	downloadColumnWidths[13+1+2];
	BOOL	downloadColumnHidden[13+1+2];
	INT		downloadColumnOrder[13+1+2];
	// [TPT] - IP Country +1
	// [TPT] - khaos::categorymod+ +3
	//[TPT] - TBH Transfers Window Style
	// [TPT] - IP Country +1
	int16	downloadClientsColumnWidths[7+1];
	BOOL	downloadClientsColumnHidden[7+1];
	INT		downloadClientsColumnOrder[7+1];
	// [TPT] - IP Country +1
	//[TPT] - TBH Transfers Window Style


	// [TPT] - itsonlyme: clientSoft +1	
	// [TPT] - IP Country +1
	// [TPT] - Total UL/DL +1
	int16	uploadColumnWidths[11];
	BOOL	uploadColumnHidden[11];
	INT		uploadColumnOrder[11];
	int16	queueColumnWidths[13];
	BOOL	queueColumnHidden[13];
	INT		queueColumnOrder[13];
	// [TPT] - Total UL/DL
	// [TPT] - IP Country
	// [TPT] - itsonlyme: clientSoft END
	int16	searchColumnWidths[12];
	BOOL	searchColumnHidden[12];
	INT		searchColumnOrder[12];
	// [TPT] - itsonlyme: virtualDirs +1
	// [TPT] -  SLUGFILLER: Spreadbars +4
	int16	sharedColumnWidths[13+1+4];
	BOOL	sharedColumnHidden[13+1+4];
	INT		sharedColumnOrder[13+1+4];
	// [TPT] -  SLUGFILLER: Spreadbars
	// [TPT] - itsonlyme: virtualDirs
	int16	serverColumnWidths[13];
	BOOL	serverColumnHidden[13];
	INT 	serverColumnOrder[13];
	// [TPT] - IP Country +1
	//eWombat [SNAFU][TPT] +1
	int16	clientListColumnWidths[8+1+1];
	BOOL	clientListColumnHidden[8+1+1];
	INT 	clientListColumnOrder[8+1+1];
	//eWombat [SNAFU][TPT]
	// [TPT] - IP Country
	// Added by [TPT]-MoNKi [MoNKi: -Downloaded History-]
	int16	m_HistoryColumnWidths[7];
	BOOL	m_HistoryColumnHidden[7];
	INT 	m_HistoryColumnOrder[7];
	// End MoNKi

	DWORD	statcolors[15];
	

	uint8	splashscreen;
	uint8	filterLANIPs;
	bool	m_bAllocLocalHostIP;
	uint8	onlineSig;

	// -khaos--+++> Struct Members for Storing Statistics
	
	// Saved stats for cumulative downline overhead...
	uint64	cumDownOverheadTotal;
	uint64	cumDownOverheadFileReq;
	uint64	cumDownOverheadSrcEx;
	uint64	cumDownOverheadServer;
	uint64	cumDownOverheadKad;
	uint64	cumDownOverheadTotalPackets;
	uint64	cumDownOverheadFileReqPackets;
	uint64	cumDownOverheadSrcExPackets;
	uint64	cumDownOverheadServerPackets;
	uint64	cumDownOverheadKadPackets;

	// Saved stats for cumulative upline overhead...
	uint64	cumUpOverheadTotal;
	uint64	cumUpOverheadFileReq;
	uint64	cumUpOverheadSrcEx;
	uint64	cumUpOverheadServer;
	uint64	cumUpOverheadKad;
	uint64	cumUpOverheadTotalPackets;
	uint64	cumUpOverheadFileReqPackets;
	uint64	cumUpOverheadSrcExPackets;
	uint64	cumUpOverheadServerPackets;
	uint64	cumUpOverheadKadPackets;

	// Saved stats for cumulative upline data...
	uint32	cumUpSuccessfulSessions;
	uint32	cumUpFailedSessions;
	uint32	cumUpAvgTime;
	// Cumulative client breakdown stats for sent bytes...
	uint64	cumUpData_EDONKEY;
	uint64	cumUpData_EDONKEYHYBRID;
	uint64	cumUpData_EMULE;
	uint64	cumUpData_MLDONKEY;
	uint64	cumUpData_CDONKEY;
	uint64	cumUpData_XMULE;
	uint64	cumUpData_SHAREAZA;
	// Session client breakdown stats for sent bytes...
	uint64	sesUpData_EDONKEY;
	uint64	sesUpData_EDONKEYHYBRID;
	uint64	sesUpData_EMULE;
	uint64	sesUpData_MLDONKEY;
	uint64	sesUpData_CDONKEY;
	uint64	sesUpData_XMULE;
	uint64	sesUpData_SHAREAZA;

	// Cumulative port breakdown stats for sent bytes...
	uint64	cumUpDataPort_4662;
	uint64	cumUpDataPort_OTHER;
	// Session port breakdown stats for sent bytes...
	uint64	sesUpDataPort_4662;
	uint64	sesUpDataPort_OTHER;

	// Cumulative source breakdown stats for sent bytes...
	uint64	cumUpData_File;
	uint64	cumUpData_Partfile;
	// Session source breakdown stats for sent bytes...
	uint64	sesUpData_File;
	uint64	sesUpData_Partfile;

	// Saved stats for cumulative downline data...
	uint32	cumDownCompletedFiles;
	uint16	cumDownSuccessfulSessions;
	uint16	cumDownFailedSessions;
	uint32	cumDownAvgTime;

	// Cumulative statistics for saved due to compression/lost due to corruption
	uint64	cumLostFromCorruption;
	uint64	cumSavedFromCompression;
	uint32	cumPartsSavedByICH;

	uint64	sesLostFromCorruption;
	uint64	sesSavedFromCompression;

	// Session statistics for download sessions
	uint16	sesDownSuccessfulSessions;
	uint16	sesDownFailedSessions;
	uint32	sesDownAvgTime;
	uint16	sesDownCompletedFiles;
	uint16	sesPartsSavedByICH;

	// Cumulative client breakdown stats for received bytes...
	uint64	cumDownData_EDONKEY;
	uint64	cumDownData_EDONKEYHYBRID;
	uint64	cumDownData_EMULE;
	uint64	cumDownData_MLDONKEY;
	uint64	cumDownData_CDONKEY;
	uint64	cumDownData_XMULE;
	uint64	cumDownData_SHAREAZA;
	// Session client breakdown stats for received bytes...
	uint64	sesDownData_EDONKEY;
	uint64	sesDownData_EDONKEYHYBRID;
	uint64	sesDownData_EMULE;
	uint64	sesDownData_MLDONKEY;
	uint64	sesDownData_CDONKEY;
	uint64	sesDownData_XMULE;
	uint64	sesDownData_SHAREAZA;

	// Cumulative port breakdown stats for received bytes...
	uint64	cumDownDataPort_4662;
	uint64	cumDownDataPort_OTHER;
	// Session port breakdown stats for received bytes...
	uint64	sesDownDataPort_4662;
	uint64	sesDownDataPort_OTHER;

	// Saved stats for cumulative connection data...
	float	cumConnAvgDownRate;
	float	cumConnMaxAvgDownRate;
	float	cumConnMaxDownRate;
	float	cumConnAvgUpRate;
	float	cumConnMaxAvgUpRate;
	float	cumConnMaxUpRate;
	uint64	cumConnRunTime;
	uint16	cumConnNumReconnects;
	uint16	cumConnAvgConnections;
	uint16	cumConnMaxConnLimitReached;
	uint16	cumConnPeakConnections;
	uint32	cumConnTransferTime;
	uint32	cumConnDownloadTime;
	uint32	cumConnUploadTime;
	uint32	cumConnServerDuration;

	// Saved records for servers / network...
	uint16	cumSrvrsMostWorkingServers;
	uint32	cumSrvrsMostUsersOnline;
	uint32	cumSrvrsMostFilesAvail;

	// Saved records for shared files...
    uint16	cumSharedMostFilesShared;
	uint64	cumSharedLargestShareSize;
	uint64	cumSharedLargestAvgFileSize;
	uint64	cumSharedLargestFileSize;

	// Save the date when the statistics were last reset...
	__int64	stat_datetimeLastReset;

	// Save new preferences for PPgStats
	uint8	statsConnectionsGraphRatio; // This will store the divisor, i.e. for 1:3 it will be 3, for 1:20 it will be 20.
	// Save the expanded branches of the stats tree
	char	statsExpandedTreeItems[256];

	// <-----khaos- End Statistics Members


	// Original Stats Stuff
	uint64  totalDownloadedBytes;
	uint64	totalUploadedBytes;
	// End Original Stats Stuff
	WORD	languageID;
	int8	transferDoubleclick;
	int8	m_iSeeShares;		// 0=everybody 1=friends only 2=noone
	int8	m_iToolDelayTime;	// tooltip delay time in seconds
	int8	bringtoforeground;
	int8	splitterbarPosition;
	uint16	deadserverretries;
	DWORD	m_dwServerKeepAliveTimeout;
	// -khaos--+++> Changed data type to avoid overflows
	uint16  statsMax;
	// <-----khaos-
	int8	statsAverageMinutes;

	// [TPT] - enkeyDEV(th1) -notifier-
	int8    useNotifierUserTimings;
	uint16  notifierUserTimeToShow;
	uint16  notifierUserTimeToStay;
	uint16  notifierUserTimeToHide;
	int8    notifierLessFramerate;
    int8    useDownloadNotifier;
	int8	notifierAutoClose;  
	int8	useErrorNotifier;	// added by InterCeptor (notify on error) 11.11.02
	int8	useNewDownloadNotifier;
    int8    useChatNotifier;
    int8    useLogNotifier;	
    int8    useSoundInNotifier;
	int8    notifierPopsEveryChatMsg;
	int8	notifierImportantError;
	int8	notifierNewVersion;
    char    notifierSoundFilePath[510];
	int8	notifierSearchCompleted;    	
	int8	notifierNewPvtMsg;//Rocks
	//END [TPT] - enkeyDEV(th1) -notifier-

	char	m_sircserver[50];
	char	m_sircnick[30];
	char	m_sircchannamefilter[50];
	bool	m_bircaddtimestamp;
	bool	m_bircusechanfilter;
	uint16	m_iircchanneluserfilter;
	char	m_sircperformstring[255];
	bool	m_bircuseperform;
	bool	m_birclistonconnect;
	bool	m_bircacceptlinks;
	bool	m_bircacceptlinksfriends;
	bool	m_bircignoreinfomessage;
	bool	m_bircignoreemuleprotoinfomessage;
	bool	m_birchelpchannel;
	
	bool	m_bRemove2bin;

	bool	m_bpreviewprio;
	bool	smartidcheck;
	uint8	smartidstate;
	bool	safeServerConnect;
	bool	startMinimized;
	bool	m_bRestoreLastMainWndDlg;
	int		m_iLastMainWndDlgID;
	bool	m_bRestoreLastLogPane;
	int		m_iLastLogPaneID;
	uint16	MaxConperFive;
	int		checkDiskspace;	// SLUGFILLER: checkDiskspace
	UINT	m_uMinFreeDiskSpace;
	char	yourHostname[127];	// itsonlyme: hostnameSource
	bool	infiniteQueue;	// [TPT] - SLUGFILLER: infiniteQueue
	// [TPT] - SLUGFILLER: hideOS
	uint8	hideOS;
	bool	selectiveShare;
	// [TPT] - SLUGFILLER: hideOS
	// [TPT] - itsonlyme: displayOptions START
	bool	showFileSystemIcon;
	bool	showLocalRating; // [TPT] - SLUGFILLER: showComments
	// [TPT] - itsonlyme: displayOptions END
	// [TPT] - quick start
	bool	m_QuickStart;
	uint16  m_QuickStartMaxCon;
	uint16  m_QuickStartMaxConPerFive;
	// [TPT] - quick start
	bool	m_bSpreadBars; // [TPT] - SLUGFILLER: Spreadbars

	bool	m_bVerbose;
	bool	m_bDebugSourceExchange; // Sony April 23. 2003, button to keep source exchange msg out of verbose log
	bool	m_bLogBannedClients;
	bool	m_bLogRatingReceived;
	bool	m_bLogDescriptionReceived;
	bool	m_bLogFilteredIPs;
	bool	m_bLogFileSaving;
	int		m_iDebugServerTCPLevel;
	int		m_iDebugServerUDPLevel;
	int		m_iDebugServerSourcesLevel;
	int		m_iDebugServerSearchesLevel;
	int		m_iDebugClientTCPLevel;
	int		m_iDebugClientUDPLevel;
	bool	m_bupdatequeuelist;
	bool	m_bmanualhighprio;
	bool	m_btransferfullchunks;
	bool	m_bstartnextfile;
	bool	m_bshowoverhead;
	bool	m_bDAP;
	bool	m_bUAP;
	bool	m_bDisableKnownClientList;
	bool	m_bDisableQueueList;
	bool	m_bExtControls;
	bool	m_bTransflstRemain;

	int8	versioncheckdays;

	// Barry - Provide a mechanism for all tables to store/retrieve sort order
	// [TPT] - SLUGFILLER: multiSort - save multiple params
	// [TPT] - SLUGFILLER: DLsortFix - double, for client-only sorting
	// [TPT] - IP Country +1
	// [TPT] - khaos::categorymod+ +2
	int		tableSortItemDownload[32];
	BOOL	tableSortAscendingDownload[32];
	// [TPT] - khaos::categorymod-
	int		tableSortItemDownloadClient[16]; //[TPT] - TBH Transfers Window Style		
	BOOL	tableSortAscendingDownloadClient[16]; //[TPT] - TBH Transfers Window Style	
	// [TPT] - IP Country
	// [TPT] - SLUGFILLER: DLsortFix
	// [TPT] - itsonlyme: clientSoft +1	
	// [TPT] - IP Country +1
	// [TPT] - Total UL/DL +1
	int		tableSortItemUpload[11];
	BOOL	tableSortAscendingUpload[11];	
	int		tableSortItemQueue[13];
	BOOL	tableSortAscendingQueue[13];
	// [TPT] - IP Country
	// [TPT] - itsonlyme: clientSoft
	int		tableSortItemSearch[12];
	BOOL	tableSortAscendingSearch[12];
	// [TPT] - itsonlyme: virtualDirs +1
	// [TPT] -  SLUGFILLER: Spreadbars +4
	int		tableSortItemShared[13+1+4];
	BOOL	tableSortAscendingShared[13+1+4];
	// [TPT] - itsonlyme: virtualDirs
	// [TPT] -  SLUGFILLER: Spreadbars
	int		tableSortItemServer[13];
	BOOL	tableSortAscendingServer[13];
	// [TPT] - IP Country +1
	//eWombat [SNAFU][TPT] +1
	int		tableSortItemClientList[10];
	BOOL	tableSortAscendingClientList[10];
	//eWombat [SNAFU][TPT]
	// [TPT] - IP Country
	// Added by [TPT]-MoNKi [MoNKi: -Downloaded History-]
	int		tableSortItemHistory[7];
	BOOL	tableSortAscendingHistory[7];
	// Added by [TPT]-MoNKi [MoNKi: -Downloaded History-]
	// [TPT] - SLUGFILLER: multiSort	

	bool	showRatesInTitle;

	char	TxtEditor[256];
	char	VideoPlayer[256];
	
	char	UpdateURLIPFilter[256];// [TPT] - Ipfilter Update MORPH START added by Yun.SF3: Ipfilter.dat update
	bool	moviePreviewBackup;
	int		m_iPreviewSmallBlocks;
	bool	indicateratings;
	bool	watchclipboard;
	bool	filterserverbyip;
	bool	m_bFirstStart;
	bool	m_bCreditSystem;
	// [TPT] - TBH: minimule
	int		speedmetermin;
	int		speedmetermax;
	// [TPT] - TBH: minimule
	bool	log2disk;
	bool	debug2disk;
	int		iMaxLogBuff;
	UINT	uMaxLogFileSize;
	bool	scheduler;
	bool	dontcompressavi;
	bool	msgonlyfriends;
	bool	msgsecure;

	uint8	filterlevel;
	uint8	m_iFileBufferSize;
	uint8	m_iQueueSize;
	int		m_iCommitFiles;

	// Added by [TPT]-MoNKi [MoNKi: -Downloaded History-]	
	bool	m_bHistoryShowShared;
	// End MoNKi

	uint16	maxmsgsessions;
	uint32	versioncheckLastAutomatic;
	char messageFilter[512];
	char commentFilter[512];
	char filenameCleanups[512];
	char notifierConfiguration[510];
	char datetimeformat[64];
	char datetimeformat4log[64];
	LOGFONT m_lfHyperText;
	int		m_iExtractMetaData;

	// Web Server [kuchin]
	char		m_sWebPassword[256];
	char		m_sWebLowPassword[256];
	uint16		m_nWebPort;
	bool		m_bWebEnabled;
	bool		m_bWebUseGzip;
	int			m_nWebPageRefresh;
	bool		m_bWebLowEnabled;
	char		m_sWebResDir[MAX_PATH];

	char		m_sTemplateFile[MAX_PATH];
	ProxySettings proxy; // deadlake PROXYSUPPORT
	bool		m_bIsASCWOP;
	bool		m_bShowProxyErrors;

	bool		showCatTabInfos;
	bool		resumeSameCat;
	bool		dontRecreateGraphs;
	bool		autofilenamecleanup;
	int			allcatType;
	bool		m_bUseAutocompl;
	bool		m_bShowDwlPercentage;
	bool		m_bRemoveFinishedDownloads;
	uint16		m_iMaxChatHistory;

	int			m_iSearchMethod;
	bool		m_bAdvancedSpamfilter;
	bool		m_bUseSecureIdent;
	// mobilemule
	char		m_sMMPassword[256];
	bool		m_bMMEnabled;
	uint16		m_nMMPort;

	bool		networkkademlia;
	bool		networked2k;

	// toolbar
	int8		m_nToolbarLabels;
	char		m_sToolbarBitmap[256];
	char		m_sToolbarBitmapFolder[256];
	char		m_sToolbarSettings[256];

	//preview
	bool		m_bPreviewEnabled;
	
	// ZZ:UploadSpeedSense -->
    /*bool        m_bDynUpEnabled;
    int         m_iDynUpPingTolerance;
    int         m_iDynUpGoingUpDivider;
    int         m_iDynUpGoingDownDivider;
    int         m_iDynUpNumberOfPings;*/
	// ZZ:UploadSpeedSense <--

	bool	cumulateBandwidth;// [TPT]-Cumulate Bandwidth

	// [TPT] - Ipfilter UpdateMORPH START added by Yun.SF3: Ipfilter.dat update
 	uint32		m_IPfilterVersion; //added by milobac: Ipfilter.dat update
	// [TPT] - Ipfilter Update MORPH END added by Yun.SF3: Ipfilter.dat update

	// added by [TPT]-MoNKi [MoNKi: -invisible mode-]
	bool		m_bInvisibleMode;		
	UINT		m_iInvisibleModeHotKeyModifier;
	char		m_cInvisibleModeHotKey;
	// End [TPT]-MoNKi

	// [TPT] - IP Country
	bool showFlags;
	bool showCountryName;
	// [TPT] - IP Country

	bool	m_bUseWindowsTextColorOnHighContrast; // [TPT] - MoNKi: -Support for High Contrast Mode-
	
	// [TPT] - khaos::categorymod+	
	bool		m_bShowCatNames;
	bool		m_bActiveCatDefault;
	bool		m_bSelCatOnAdd;
	bool		m_bAutoSetResumeOrder;	
	uint8		m_iStartDLInEmptyCats;
	bool		m_bRespectMaxSources;
	bool		m_bUseAutoCat;
	// [TPT] - khaos::categorymod-

};
#pragma pack()

#pragma pack(1)
struct Preferences_Import19c_Struct{
	int8	version;
	char	nick[50];
	uint16	maxupload;
	uint16	maxdownload;
	uint16	port;
	uint16	maxconnections;
	int8	reconnect;
	int8	deadserver;
	int8	scorsystem;
	char	incomingdir[510];
	char	tempdir[510];
	int8	ICH;
	int8	autoserverlist;
	int8	updatenotify;
	int8	mintotray;
	uchar	userhash[16];
	int8	autoconnect;
	int8	addserversfromserver;
	int8	addserversfromclient;
};
#pragma pack()

#pragma pack(1)
struct Preferences_Import20a_Struct{
	int8	version;
	char	nick[50];
	uint16	maxupload;
	uint16	maxdownload;
	uint16	port;
	uint16	maxconnections;
	int8	reconnect;
	int8	deadserver;
	uint16	deadserverretries;
	int8	scorsystem;
	char	incomingdir[510];
	char	tempdir[510];
	int8	ICH;
	int8	autoserverlist;
	int8	updatenotify;
	int8	mintotray;
	uchar	userhash[16];
	int8	autoconnect;
	int8	addserversfromserver;
	int8	addserversfromclient;
	int16	maxsourceperfile;
	int16	trafficOMeterInterval;
	int32   totalDownloaded;
	int32	totalUploaded;
	int		maxGraphDownloadRate;
	int		maxGraphUploadRate;
	uint8	beepOnError;
	uint8	confirmExit;
	WINDOWPLACEMENT EmuleWindowPlacement;
	int transferColumnWidths[9];
	int serverColumnWidths[8];
	uint8	splashscreen;
	uint8	filterLANIPs;
};
#pragma pack()

#pragma pack(1)
struct Preferences_Import20b_Struct{
	int8	version;
	char	nick[50];
	uint16	maxupload;
	uint16	maxdownload;
	uint16	port;
	uint16	maxconnections;
	int8	reconnect;
	int8	deadserver;
	int8	scorsystem;
	char	incomingdir[510];
	char	tempdir[510];
	int8	ICH;
	int8	autoserverlist;
	int8	updatenotify;
	int8	mintotray;
	uchar	userhash[16];
	int8	autoconnect;
	int8	addserversfromserver;
	int8	addserversfromclient;
	int16	maxsourceperfile;
	int16	trafficOMeterInterval;
	int32   totalDownloaded;	// outdated
	int32	totalUploaded;		// outdated
	int		maxGraphDownloadRate;
	int		maxGraphUploadRate;
	uint8	beepOnError;
	uint8	confirmExit;
	WINDOWPLACEMENT EmuleWindowPlacement;
	int transferColumnWidths[9];
	int serverColumnWidths[8];
	uint8	splashscreen;
	uint8	filterLANIPs;
	int64   totalDownloadedBytes;
	int64	totalUploadedBytes;
};
#pragma pack()

// [TPT] - Select process priority 
#define PROCESSPRIORITYNUMBER 6
static const PriorityClasses[] = { REALTIME_PRIORITY_CLASS, HIGH_PRIORITY_CLASS, ABOVE_NORMAL_PRIORITY_CLASS, NORMAL_PRIORITY_CLASS, BELOW_NORMAL_PRIORITY_CLASS, IDLE_PRIORITY_CLASS };
// [TPT] - Select process priority 

class CPreferences: public CLoggable
{
public:

	//emulEspaa: Modified by MoNKi [MoNKi: -Downloaded History-]
	// [TPT] - TBH Transfers Window Style
	/*
	enum Table { tableDownload, tableUpload, tableQueue, tableSearch,
		tableShared, tableServer, tableClientList };
	*/
	enum Table { tableDownload, tableDownloadClients, tableUpload, tableQueue, tableSearch,
		tableShared, tableServer, tableClientList, tableHistory };

	friend class CPreferencesWnd;
	friend class CPPgGeneral;
	friend class CPPgConnection;
	friend class CPPgServer;
	friend class CPPgDirectories;
	friend class CPPgFiles;
	friend class CPPgNotify;
	friend class CPPgIRC;
	friend class Wizard;
	friend class CPPgTweaks;
	friend class CPPgDisplay;
	friend class CPPgSecurity;
	friend class CPPgScheduler;
	friend class CPPgDebug;
	friend class CPPgMaella; // [TPT]
	friend class CPPgPhoenix; // [TPT]

	// Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-
	float	GetMaxUpload() const {return prefs->maxupload;}
	void	SetMaxUpload(float in) {prefs->maxupload = in;}

	float	GetMaxDownload() const; // rate limited
	void	SetMaxDownload(float in) {prefs->maxdownload = in;}

	float	GetMaxGraphUploadRate() const {return prefs->maxGraphUploadRate;}
	void	SetMaxGraphUploadRate(float in) {prefs->maxGraphUploadRate=in;}

	float	GetMaxGraphDownloadRate() const {return prefs->maxGraphDownloadRate;}
	void	SetMaxGraphDownloadRate(float in) {prefs->maxGraphDownloadRate=in;}
	// Maella end

	// Maella -Enable/Disable source exchange in preference- (Tarod)
	bool	GetDisabledXS() const { return prefs->disablexs; } 
	void 	SetDisabledXS(bool flag) { prefs->disablexs = flag; } 
	// Maella end

	// Maella -Reask sources after IP change- (idea Xman)
	bool	GetReaskSourceAfterIPChange() const { return prefs->reaskSourceAfterIPChange; } 
	void 	SetReaskSourceAfterIPChange(bool flag) { prefs->reaskSourceAfterIPChange = flag; } 
	// Maella end

	// Maella -Graph: display zoom-
	uint8	GetZoomFactor() const { return prefs->zoomFactor; }
	void	SetZoomFactor(uint8 zoom) { prefs->zoomFactor = zoom; }
	// Maella end

	// Maella -Defeat 0-filled Part Senders- (Idea of xrmb)
	bool	GetCorruptionTest() const { return prefs->enableCorruptionTest; }
	void	SetCorruptionTest(bool flag) { prefs->enableCorruptionTest = flag; }
	bool	GetSkipCorruptionCDTest() const { return prefs->enableSkipCorruptionCDTest; }
	void	SetSkipCorruptionCDTest(bool flag) { prefs->enableSkipCorruptionCDTest = flag; }
	// Maella end

	// Maella -Filter verbose messages-
	bool	GetBlockUploadEndMsg() const { return prefs->blockUploadEndMsg; }
	void	SetBlockUploadEndMsg(bool flag) { prefs->blockUploadEndMsg = flag; }		

	// [TPT] - Filter own messages
	bool	GetBlockPhoenixMsg() const { return prefs->blockPhoenixMsg; }
	void	SetBlockPhoenixMsg(bool flag) { prefs->blockPhoenixMsg = flag; }		

	// [TPT] - Filter Handshake messages
	bool	GetBlockHandshakeMsg() const { return prefs->blockHandshakeMsg; }
	void	SetBlockHandshakeMsg(bool flag) { prefs->blockHandshakeMsg= flag; }		
	
	bool	GetBlockFilteredIPSourceMsg() const { return prefs->blockFilteredIPSourceMsg; }
	void	SetBlockFilteredIPSourceMsg(bool flag) { prefs->blockFilteredIPSourceMsg = flag; }
	bool	GetBlockFilteredIPServerMsg() const { return prefs->blockFilteredIPServerMsg; }
	void	SetBlockFilteredIPServerMsg(bool flag) { prefs->blockFilteredIPServerMsg = flag; }
	bool	GetBlockMaellaSpecificMsg() const { return prefs->blockMaellaSpecificMsg; }
	void	SetBlockMaellaSpecificMsg(bool flag) { prefs->blockMaellaSpecificMsg = flag; }
	bool	GetBlockMaellaSpecificDebugMsg() const { return prefs->blockMaellaSpecificDebugMsg; }
	void	SetBlockMaellaSpecificDebugMsg(bool flag) { prefs->blockMaellaSpecificDebugMsg = flag; }
	// Maella end

	// Maella -Overhead compensation (pseudo full rate control)-
	bool	GetCompensateOverhead() const {return prefs->compensateOverhead || (prefs->NAFCEnable && prefs->NAFCFullControl);}
	void	SetCompensateOverhead(bool flag) { prefs->compensateOverhead = flag; }
	// Maella end

	// Maella -MTU Configuration-
	uint16	GetMTU() const { return prefs->MTU; }
	void	SetMTU(uint16 MTU) { prefs->MTU = MTU; }
	// Maella end

	// Maella -Minimum Upload Slot-
	uint16	GetMinUploadSlot() const { return prefs->minUploadSlot; }
	void	SetMinUploadSlot(uint16 minUploadSlot) { prefs->minUploadSlot = minUploadSlot; }
	// Maella end

	// Maella -New bandwidth control-
	uint16	GetSendSocketBufferSize() const { return prefs->sendSocketBufferSize; }
	void	SetSendSocketBufferSize(uint16 size) { prefs->sendSocketBufferSize = size; }
	// Maella end

	// Maella -Network Adapter Feedback Control-
	bool	GetNAFCEnable() const { return prefs->NAFCEnable; }
	void	SetNAFCEnable(bool flag) { prefs->NAFCEnable = flag; }
	bool	GetNAFCFullControl() const { return prefs->NAFCFullControl; }
	void	SetNAFCFullControl(bool flag) { prefs->NAFCFullControl = flag; }
	float	GetNAFCNetworkOut() const { return prefs->NAFCNetworkOut; }
	void	SetNAFCNetworkOut(float rate) { prefs->NAFCNetworkOut = rate; }
	// Maella end

	// Maella -Accurate measure of bandwidth: eDonkey data + control, network adapter-
	uint8 GetDatarateSamples() const { return prefs->datarateSamples; }
	void  SetDatarateSamples(uint8 samples) { prefs->datarateSamples = samples; }
	// Maella end

	// Maella -One-queue-per-file- (idea bloodymad)
	bool GetEnableMultiQueue() const { return prefs->enableMultiQueue; }
	void SetEnableMultiQueue(bool state) { prefs->enableMultiQueue = state; }
	bool GetEnableReleaseMultiQueue() const { return prefs->enableReleaseMultiQueue; }
	void SetEnableReleaseMultiQueue(bool state) { prefs->enableReleaseMultiQueue = state; }
	bool GetEnableNewUSS() const { return prefs->enableNewUSS || (prefs->NAFCEnable && prefs->NAFCFullControl); }
	void SetEnableNewUSS(bool state) { prefs->enableNewUSS = state; }
	// Maella end

	//eWombat [SNAFU][TPT]
	void SetEnableSnafu(bool state) { prefs->m_bSnafu = state; }
	void SetEnableACT(bool state) { prefs->m_bAntiCreditTheft = state; }
	void SetEnableAntiFriendshare(bool state) { prefs->m_bAntiFriendshare = state; }
	//eWombat [SNAFU][TPT] end

	// Maella -Auto A4AF-	
	bool GetEnableA4AFTransfer() const { return prefs->enableA4AFTransfer; }
	void SetEnableA4AFTransfer(bool state) { prefs->enableA4AFTransfer = state; }
	// Maella end

	// [TPT] - IP Country
	bool GetEnableShowCountryNames() const { return prefs->showFlags; }
	bool GetEnableShowCountryFlags() const { return prefs->showCountryName; }	
	// [TPT] - IP Country

	const CString&	GetLinkDir() const		{return ed2klinkdir;}	 // [TPT] - Save ed2klinks

	CPreferences();
	~CPreferences();

	const CString& GetAppDir() const		{return appdir;}
	LPCTSTR	GetIncomingDir() const			{return prefs->incomingdir;}
	LPCTSTR	GetTempDir() const				{return prefs->tempdir;}
	const CString& GetConfigDir() const		{return configdir;}
	const CString& GetWebServerDir() const	{return m_strWebServerDir;}

	bool	IsTempFile(const CString& rstrDirectory, const CString& rstrName) const;
	bool	IsConfigFile(const CString& rstrDirectory, const CString& rstrName) const; // SLUGFILLER: SafeHash
	bool	IsShareableDirectory(const CString& rstrDirectory) const;
	bool	IsInstallationDirectory(const CString& rstrDir) const;

	bool	Save();
	void	SaveCats();
	// [TPT] - itsonlyme: virtualDirs
	void	LoadVirtualDirs();
	bool	SaveVirtualDirs();
	// [TPT] - itsonlyme: virtualDirs

	int8	Score()			{return prefs->scorsystem;}
	bool	Reconnect()		{return prefs->reconnect;}
	int8	DeadServer()	{return prefs->deadserver;}
	char*	GetUserNick()	{return prefs->nick;}
	void	SetUserNick(CString in);	// [TPT] - itsonlyme: viewSharedFiles

	uint16	GetPort()		{return prefs->port;}
	uint16	GetUDPPort()	{return prefs->udpport;}
	uint16	GetServerUDPPort(){return prefs->nServerUDPPort;}
	uint16	GetKadUDPPort()	{return prefs->kadudpport;}
	void	SetKadUDPPort( uint16 in_val )	{prefs->kadudpport = in_val;}
	char*	GetUserHash()	{return userhash;}
	// ZZ:UploadSpeedSense -->
    //uint16  GetMinUpload()  {return prefs->minupload;}
	// ZZ:UploadSpeedSense <--
	//uint16	GetMaxUpload()	{return	prefs->maxupload;}
	bool	IsICHEnabled()	{return prefs->ICH;}
	bool	AutoServerlist(){return prefs->autoserverlist;}
	bool	UpdateNotify()	{return prefs->updatenotify;}
	bool	DoMinToTray()	{return prefs->mintotray;}
	bool	DoAutoConnect() {return prefs->autoconnect;}
	void	SetAutoConnect( bool inautoconnect)	{prefs->autoconnect = inautoconnect;}
	bool	AddServersFromServer()		{return prefs->addserversfromserver;}
	bool	AddServersFromClient()		{return prefs->addserversfromclient;}
	int8*	GetMinTrayPTR() {return &prefs->mintotray;}
	uint16	GetTrafficOMeterInterval() { return prefs->trafficOMeterInterval;}
	void	SetTrafficOMeterInterval(int16 in) { prefs->trafficOMeterInterval=in;}
	uint16	GetStatsInterval() { return prefs->statsInterval;}
	void	SetStatsInterval(int16 in) { prefs->statsInterval=in;}
	void	Add2TotalDownloaded(uint64 in) {prefs->totalDownloadedBytes+=in;}
	void	Add2TotalUploaded(uint64 in) {prefs->totalUploadedBytes+=in;}

	// -khaos--+++> Many, many, many, many methods.
	void	SaveStats(int bBackUp = 0);
	void	SetRecordStructMembers();
	void	SaveCompletedDownloadsStat();
	bool	LoadStats(int loadBackUp = 0);
	void	ResetCumulativeStatistics();

	//		Functions from base code that update original cumulative stats, now obsolete. (KHAOS)
	//void	Add2TotalDownloaded(uint64 in) {prefs->totalDownloadedBytes+=in;}
	//void	Add2TotalUploaded(uint64 in) {prefs->totalUploadedBytes+=in;}
	//		End functions from base code.

	//		Add to, increment and replace functions.  They're all named Add2 for the sake of some kind of naming
	//		convention.
	void	Add2DownCompletedFiles()			{ prefs->cumDownCompletedFiles++; }
	void	Add2ConnMaxAvgDownRate(float in)	{ prefs->cumConnMaxAvgDownRate = in; }
	void	Add2ConnMaxDownRate(float in)		{ prefs->cumConnMaxDownRate = in; }
	void	Add2ConnAvgUpRate(float in)			{ prefs->cumConnAvgUpRate = in; }
	void	Add2ConnMaxAvgUpRate(float in)		{ prefs->cumConnMaxAvgUpRate = in; }
	void	Add2ConnMaxUpRate(float in)			{ prefs->cumConnMaxUpRate = in; }
	void	Add2ConnPeakConnections(int in)		{ prefs->cumConnPeakConnections = in; }
	void	Add2UpAvgTime(int in)				{ prefs->cumUpAvgTime = in; }
	void	Add2DownSAvgTime(int in)			{ prefs->sesDownAvgTime += in; }
	void	Add2DownCAvgTime(int in)			{ prefs->cumDownAvgTime = in; }
	void	Add2ConnTransferTime(int in)		{ prefs->cumConnTransferTime += in; }
	void	Add2ConnDownloadTime(int in)		{ prefs->cumConnDownloadTime += in; }
	void	Add2ConnUploadTime(int in)			{ prefs->cumConnUploadTime += in; }
	void	Add2DownSessionCompletedFiles()		{ prefs->sesDownCompletedFiles++; }
	void	Add2SessionTransferData				( uint8 uClientID , uint16 uClientPort , BOOL bFromPF, BOOL bUpDown, uint32 bytes );
	void	Add2DownSuccessfulSessions()		{ prefs->sesDownSuccessfulSessions++;
												  prefs->cumDownSuccessfulSessions++; }
	void	Add2DownFailedSessions()			{ prefs->sesDownFailedSessions++;
												  prefs->cumDownFailedSessions++; }
	void	Add2LostFromCorruption(uint64 in)	{ prefs->sesLostFromCorruption += in;}
	void	Add2SavedFromCompression(uint64 in)	{ prefs->sesSavedFromCompression += in;}
	void	Add2SessionPartsSavedByICH(int in)	{ prefs->sesPartsSavedByICH += in;}

	//		Functions that return stats stuff...
	//		Saved stats for cumulative downline overhead
	uint64	GetDownOverheadTotal()			{ return prefs->cumDownOverheadTotal;}
	uint64	GetDownOverheadFileReq()		{ return prefs->cumDownOverheadFileReq;}
	uint64	GetDownOverheadSrcEx()			{ return prefs->cumDownOverheadSrcEx;}
	uint64	GetDownOverheadServer()			{ return prefs->cumDownOverheadServer;}
	uint64	GetDownOverheadKad()			{ return prefs->cumDownOverheadKad;}
	uint64	GetDownOverheadTotalPackets()	{ return prefs->cumDownOverheadTotalPackets;}
	uint64	GetDownOverheadFileReqPackets() { return prefs->cumDownOverheadFileReqPackets;}
	uint64	GetDownOverheadSrcExPackets()	{ return prefs->cumDownOverheadSrcExPackets;}
	uint64	GetDownOverheadServerPackets()	{ return prefs->cumDownOverheadServerPackets;}
	uint64	GetDownOverheadKadPackets()		{ return prefs->cumDownOverheadKadPackets;}

	//		Saved stats for cumulative upline overhead
	uint64	GetUpOverheadTotal()			{ return prefs->cumUpOverheadTotal;}
	uint64	GetUpOverheadFileReq()			{ return prefs->cumUpOverheadFileReq;}
	uint64	GetUpOverheadSrcEx()			{ return prefs->cumUpOverheadSrcEx;}
	uint64	GetUpOverheadServer()			{ return prefs->cumUpOverheadServer;}
	uint64	GetUpOverheadKad()				{ return prefs->cumUpOverheadKad;}
	uint64	GetUpOverheadTotalPackets()		{ return prefs->cumUpOverheadTotalPackets;}
	uint64	GetUpOverheadFileReqPackets()	{ return prefs->cumUpOverheadFileReqPackets;}
	uint64	GetUpOverheadSrcExPackets()		{ return prefs->cumUpOverheadSrcExPackets;}
	uint64	GetUpOverheadServerPackets()	{ return prefs->cumUpOverheadServerPackets;}
	uint64	GetUpOverheadKadPackets()		{ return prefs->cumUpOverheadKadPackets;}

	//		Saved stats for cumulative upline data
	uint32	GetUpSuccessfulSessions()		{ return prefs->cumUpSuccessfulSessions;}
	uint32	GetUpFailedSessions()			{ return prefs->cumUpFailedSessions;}
	uint32	GetUpAvgTime()					{ return prefs->cumUpAvgTime;}

	// [TPT] - Credit System
	void	SetCreditSystem(uint8 m_iInCreditSystem)	{prefs->m_iCreditSystem = m_iInCreditSystem;}
	int		GetCreditSystem()					{return prefs->m_iCreditSystem;}
	bool	UseCreditSystem()					{if (prefs->m_iCreditSystem != 4) return true; else return false;}
	// [TPT] - Credit System	

	bool	IsSpreadBarsEnable()			{ return prefs->m_bSpreadBars;} // [TPT] - SLUGFILLER: Spreadbars

	//		Saved stats for cumulative downline data
	uint32	GetDownCompletedFiles()			{ return prefs->cumDownCompletedFiles;}
	uint16	GetDownC_SuccessfulSessions()	{ return prefs->cumDownSuccessfulSessions;}
	uint16	GetDownC_FailedSessions()		{ return prefs->cumDownFailedSessions;}
	uint32	GetDownC_AvgTime()				{ return prefs->cumDownAvgTime;}
	//		Session download stats
	uint16	GetDownSessionCompletedFiles()	{ return prefs->sesDownCompletedFiles;}
	uint16	GetDownS_SuccessfulSessions()	{ return prefs->sesDownSuccessfulSessions;}
	uint16	GetDownS_FailedSessions()		{ return prefs->sesDownFailedSessions;}
	uint32	GetDownS_AvgTime()				{ return GetDownS_SuccessfulSessions()?prefs->sesDownAvgTime/GetDownS_SuccessfulSessions():0;}

	//		Saved stats for corruption/compression
	uint64	GetCumLostFromCorruption()			{ return prefs->cumLostFromCorruption;}
	uint64	GetCumSavedFromCompression()		{ return prefs->cumSavedFromCompression;}
	uint64	GetSesLostFromCorruption()			{ return prefs->sesLostFromCorruption;}
	uint64	GetSesSavedFromCompression()		{ return prefs->sesSavedFromCompression;}
	uint32	GetPartsSavedByICH()			{ return prefs->cumPartsSavedByICH;}

	// Cumulative client breakdown stats for sent bytes
	uint64	GetUpTotalClientData()			{ return (GetCumUpData_EDONKEY() +			GetCumUpData_EDONKEYHYBRID() +
													  GetCumUpData_EMULE() +			GetCumUpData_MLDONKEY() +
													  GetCumUpData_CDONKEY() );}
	uint64	GetCumUpData_EDONKEY()			{ return (prefs->cumUpData_EDONKEY +		prefs->sesUpData_EDONKEY );}
	uint64	GetCumUpData_EDONKEYHYBRID()	{ return (prefs->cumUpData_EDONKEYHYBRID +	prefs->sesUpData_EDONKEYHYBRID );}
	uint64	GetCumUpData_EMULE()			{ return (prefs->cumUpData_EMULE +			prefs->sesUpData_EMULE );}
	uint64	GetCumUpData_MLDONKEY()			{ return (prefs->cumUpData_MLDONKEY +		prefs->sesUpData_MLDONKEY );}
	uint64	GetCumUpData_CDONKEY()			{ return (prefs->cumUpData_CDONKEY +		prefs->sesUpData_CDONKEY );}
	uint64	GetCumUpData_XMULE()			{ return (prefs->cumUpData_XMULE +			prefs->sesUpData_XMULE );}
	uint64	GetCumUpData_SHAREAZA()			{ return (prefs->cumUpData_SHAREAZA +			prefs->sesUpData_SHAREAZA );}
	// Session client breakdown stats for sent bytes
	uint64	GetUpSessionClientData()		{ return (prefs->sesUpData_EDONKEY +		prefs->sesUpData_EDONKEYHYBRID +
													  prefs->sesUpData_EMULE +			prefs->sesUpData_MLDONKEY +
													  prefs->sesUpData_CDONKEY ); }
	uint64	GetUpData_EDONKEY()				{ return prefs->sesUpData_EDONKEY;}
	uint64	GetUpData_EDONKEYHYBRID()		{ return prefs->sesUpData_EDONKEYHYBRID;}
	uint64	GetUpData_EMULE()				{ return prefs->sesUpData_EMULE;}
	uint64	GetUpData_MLDONKEY()			{ return prefs->sesUpData_MLDONKEY;}
	uint64	GetUpData_CDONKEY()				{ return prefs->sesUpData_CDONKEY;}
	uint64	GetUpData_XMULE()				{ return prefs->sesUpData_XMULE;}
	uint64	GetUpData_SHAREAZA()				{ return prefs->sesUpData_SHAREAZA;}
	
	// Cumulative port breakdown stats for sent bytes...
	uint64	GetUpTotalPortData()			{ return (GetCumUpDataPort_4662() +			GetCumUpDataPort_OTHER() );}
	uint64	GetCumUpDataPort_4662()			{ return (prefs->cumUpDataPort_4662 +		prefs->sesUpDataPort_4662 );}
	uint64	GetCumUpDataPort_OTHER()		{ return (prefs->cumUpDataPort_OTHER +		prefs->sesUpDataPort_OTHER );}
	// Session port breakdown stats for sent bytes...
	uint64	GetUpSessionPortData()			{ return (prefs->sesUpDataPort_4662 +		prefs->sesUpDataPort_OTHER );}
	uint64	GetUpDataPort_4662()			{ return prefs->sesUpDataPort_4662;}
	uint64	GetUpDataPort_OTHER()			{ return prefs->sesUpDataPort_OTHER;}

	// Cumulative DS breakdown stats for sent bytes...
	uint64	GetUpTotalDataFile()			{ return (GetCumUpData_File() +				GetCumUpData_Partfile() );}
	uint64	GetCumUpData_File()				{ return (prefs->cumUpData_File +			prefs->sesUpData_File );}
	uint64	GetCumUpData_Partfile()			{ return (prefs->sesUpData_Partfile +		prefs->sesUpData_Partfile );}
	// Session DS breakdown stats for sent bytes...
	uint64	GetUpSessionDataFile()			{ return (prefs->sesUpData_File +			prefs->sesUpData_Partfile );}
	uint64	GetUpData_File()				{ return prefs->sesUpData_File;}
	uint64	GetUpData_Partfile()			{ return prefs->sesUpData_Partfile;}

	// Cumulative client breakdown stats for received bytes
	uint64	GetDownTotalClientData()		{ return (GetCumDownData_EDONKEY() +			GetCumDownData_EDONKEYHYBRID() +
													  GetCumDownData_EMULE() +				GetCumDownData_MLDONKEY() +
													  GetCumDownData_CDONKEY() ); }
	uint64	GetCumDownData_EDONKEY()		{ return (prefs->cumDownData_EDONKEY +			prefs->sesDownData_EDONKEY);}
	uint64	GetCumDownData_EDONKEYHYBRID()	{ return (prefs->cumDownData_EDONKEYHYBRID +	prefs->sesDownData_EDONKEYHYBRID);}
	uint64	GetCumDownData_EMULE()			{ return (prefs->cumDownData_EMULE +			prefs->sesDownData_EMULE);}
	uint64	GetCumDownData_MLDONKEY()		{ return (prefs->cumDownData_MLDONKEY +			prefs->sesDownData_MLDONKEY);}
	uint64	GetCumDownData_CDONKEY()		{ return (prefs->cumDownData_CDONKEY +			prefs->sesDownData_CDONKEY);}
	uint64	GetCumDownData_XMULE()			{ return (prefs->cumDownData_XMULE +			prefs->sesDownData_XMULE );}
	uint64	GetCumDownData_SHAREAZA()		{ return (prefs->cumDownData_SHAREAZA +			prefs->sesDownData_SHAREAZA );}
	// Session client breakdown stats for received bytes
	uint64	GetDownSessionClientData()		{ return (prefs->sesDownData_EDONKEY +			prefs->sesDownData_EDONKEYHYBRID +
													  prefs->sesDownData_EMULE +			prefs->sesDownData_MLDONKEY +
													  prefs->sesDownData_CDONKEY ); }
	uint64	GetDownData_EDONKEY()			{ return prefs->sesDownData_EDONKEY;}
	uint64	GetDownData_EDONKEYHYBRID()		{ return prefs->sesDownData_EDONKEYHYBRID;}
	uint64	GetDownData_EMULE()				{ return prefs->sesDownData_EMULE;}
	uint64	GetDownData_MLDONKEY()			{ return prefs->sesDownData_MLDONKEY;}
	uint64	GetDownData_CDONKEY()			{ return prefs->sesDownData_CDONKEY;}
	uint64	GetDownData_XMULE()				{ return prefs->sesDownData_XMULE;}
	uint64	GetDownData_SHAREAZA()			{ return prefs->sesDownData_SHAREAZA;}

	// Cumulative port breakdown stats for received bytes...
	uint64	GetDownTotalPortData()			{ return (GetCumDownDataPort_4662() +			GetCumDownDataPort_OTHER() );}
	uint64	GetCumDownDataPort_4662()		{ return (prefs->cumDownDataPort_4662 +			prefs->sesDownDataPort_4662 );}
	uint64	GetCumDownDataPort_OTHER()		{ return (prefs->cumDownDataPort_OTHER +		prefs->sesDownDataPort_OTHER );}
	// Session port breakdown stats for received bytes...
	uint64	GetDownSessionDataPort()		{ return (prefs->sesDownDataPort_4662 +			prefs->sesDownDataPort_OTHER );}
	uint64	GetDownDataPort_4662()			{ return prefs->sesDownDataPort_4662;}
	uint64	GetDownDataPort_OTHER()			{ return prefs->sesDownDataPort_OTHER;}

	//		Saved stats for cumulative connection data
	float	GetConnAvgDownRate()			{ return prefs->cumConnAvgDownRate;}
	float	GetConnMaxAvgDownRate()			{ return prefs->cumConnMaxAvgDownRate;}
	float	GetConnMaxDownRate()			{ return prefs->cumConnMaxDownRate;}
	float	GetConnAvgUpRate()				{ return prefs->cumConnAvgUpRate;}
	float	GetConnMaxAvgUpRate()			{ return prefs->cumConnMaxAvgUpRate;}
	float	GetConnMaxUpRate()				{ return prefs->cumConnMaxUpRate;}
	uint64	GetConnRunTime()				{ return prefs->cumConnRunTime;}
	uint16	GetConnNumReconnects()			{ return prefs->cumConnNumReconnects;}
	uint16	GetConnAvgConnections()			{ return prefs->cumConnAvgConnections;}
	uint16	GetConnMaxConnLimitReached()	{ return prefs->cumConnMaxConnLimitReached;}
	uint16	GetConnPeakConnections()		{ return prefs->cumConnPeakConnections;}
	uint32	GetConnTransferTime()			{ return prefs->cumConnTransferTime;}
	uint32	GetConnDownloadTime()			{ return prefs->cumConnDownloadTime;}
	uint32	GetConnUploadTime()				{ return prefs->cumConnUploadTime;}
	uint32	GetConnServerDuration()			{ return prefs->cumConnServerDuration;}

	//		Saved records for servers / network
	uint16	GetSrvrsMostWorkingServers()	{ return prefs->cumSrvrsMostWorkingServers;}
	uint32	GetSrvrsMostUsersOnline()		{ return prefs->cumSrvrsMostUsersOnline;}
	uint32	GetSrvrsMostFilesAvail()		{ return prefs->cumSrvrsMostFilesAvail;}

	//		Saved records for shared files
	uint16	GetSharedMostFilesShared()		{ return prefs->cumSharedMostFilesShared;}
	uint64	GetSharedLargestShareSize()		{ return prefs->cumSharedLargestShareSize;}
	uint64	GetSharedLargestAvgFileSize()	{ return prefs->cumSharedLargestAvgFileSize;}
	uint64	GetSharedLargestFileSize()		{ return prefs->cumSharedLargestFileSize;}

	//		Get the long date/time when the stats were last reset
	__int64	GetStatsLastResetLng()			{ return prefs->stat_datetimeLastReset;}
	CString	GetStatsLastResetStr(bool formatLong = true);

	//		Get and Set our new preferences
	void	SetStatsMax(uint16 in)						{ prefs->statsMax = in; }
	void	SetStatsConnectionsGraphRatio(uint8 in)		{ prefs->statsConnectionsGraphRatio = in; }
	uint8	GetStatsConnectionsGraphRatio()				{ return prefs->statsConnectionsGraphRatio; }
	void	SetExpandedTreeItems(CString in)			{ sprintf(prefs->statsExpandedTreeItems,"%s",in); }
	CString GetExpandedTreeItems()						{ return (CString)prefs->statsExpandedTreeItems; }
	// <-----khaos- End Statistics Methods

	//		Original Statistics Functions
	uint64  GetTotalDownloaded()			{return prefs->totalDownloadedBytes;}
	uint64	GetTotalUploaded()				{return prefs->totalUploadedBytes;}
	//		End Original Statistics Functions
	bool	IsErrorBeepEnabled()		{return prefs->beepOnError;}
	bool	IsConfirmExitEnabled()		{return prefs->confirmExit;}
	bool	UseSplashScreen()			{return prefs->splashscreen;}
	bool	FilterLANIPs()				{return prefs->filterLANIPs;}
	bool	GetAllowLocalHostIP()		{return prefs->m_bAllocLocalHostIP;}
	bool	IsOnlineSignatureEnabled()  {return prefs->onlineSig;}
	//int		GetMaxGraphUploadRate()		{return prefs->maxGraphUploadRate;}
	//int		GetMaxGraphDownloadRate()		{return prefs->maxGraphDownloadRate;}
	//void	SetMaxGraphUploadRate(int in)	{prefs->maxGraphUploadRate  =(in)?in:16;}
	//void	SetMaxGraphDownloadRate(int in)	{prefs->maxGraphDownloadRate=(in)?in:96;}

	//uint16	GetMaxDownload();
	uint16	GetMaxConnections()			{return	prefs->maxconnections;}
	uint16	GetMaxSourcePerFile()		{return prefs->maxsourceperfile;}
	uint16	GetMaxSourcePerFileSoft();
	uint16	GetMaxSourcePerFileUDP();
	uint16	GetDeadserverRetries()		{return prefs->deadserverretries;}
	DWORD	GetServerKeepAliveTimeout()	{return prefs->m_dwServerKeepAliveTimeout;}

	int     GetColumnWidth (Table t, int index) const;
	BOOL    GetColumnHidden(Table t, int index) const;
	int     GetColumnOrder (Table t, int index) const;
	void	SetColumnWidth (Table t, int index, int width);
	void	SetColumnHidden(Table t, int index, BOOL bHidden);
	void	SetColumnOrder (Table t, INT *piOrder);

	// Barry - Provide a mechanism for all tables to store/retrieve sort order
	// [TPT] - SLUGFILLER: multiSort
	int		GetColumnSortItem (Table t, int column = 0) const;
	bool	GetColumnSortAscending (Table t, int column = 0) const;
	int		GetColumnSortCount(Table t) const;
	// [TPT] - SLUGFILLER: multiSort
	void	SetColumnSortItem (Table t, int sortItem);
	void	SetColumnSortAscending (Table t, bool sortAscending);

	WORD	GetLanguageID() const;
	void	SetLanguageID(WORD lid);
	void	GetLanguages(CWordArray& aLanguageIDs) const;
	void	SetLanguage();
	const CString& GetLangDir() const {return m_strLangDir;}
	bool	IsLanguageSupported(LANGID lidSelected, bool bUpdateBefore);
	CString	GetLangDLLNameByID(LANGID lidSelected);

	int8	IsDoubleClickEnabled()		{return prefs->transferDoubleclick;}
	int8	CanSeeShares(void)			{return prefs->m_iSeeShares;}
	int8	ServePreview(void)			{return prefs->m_iSeeShares;}
	// [TPT] - MFCK [addon] - New Tooltips [Rayita]
	uint32	GetToolTipDelay(void) const	{ return prefs->m_iToolDelayTime ? (uint32)prefs->m_iToolDelayTime * 1000 : 500; }
	// [TPT] - MFCK [addon] - New Tooltips [Rayita]
	int8	IsBringToFront()			{return prefs->bringtoforeground;}

	int8    GetSplitterbarPosition()	{return prefs->splitterbarPosition;}
	void	SetSplitterbarPosition(int8 pos) {prefs->splitterbarPosition=pos;}
	// -khaos--+++> Changed datatype to avoid overflows
	uint16	GetStatsMax()				{return prefs->statsMax;}
	// <-----khaos-
	int8	UseFlatBar()				{return (prefs->depth3D==0);}
	int		GetStraightWindowStyles()	{return prefs->m_iStraightWindowStyles;}
	LPCTSTR GetSkinProfile()			{return prefs->m_szSkinProfile;}
	CString GetSkinProfileDir()			{return prefs->m_szSkinProfileDir;}
	void	SetSkinProfile(LPCTSTR pszProfile) { _sntprintf(prefs->m_szSkinProfile, ARRSIZE(prefs->m_szSkinProfile), _T("%s"), pszProfile); }
	void	SetSkinProfileDir(LPCTSTR pszDir) { _sntprintf(prefs->m_szSkinProfileDir, ARRSIZE(prefs->m_szSkinProfileDir), _T("%s"), pszDir); }
	int8	GetStatsAverageMinutes()	{return prefs->statsAverageMinutes;}
	void	SetStatsAverageMinutes(int8 in)	{prefs->statsAverageMinutes=in;}

	// [TPT] - enkeyDEV(th1) -notifier-
	bool    GetUseNotifierUserTimings() {return prefs->useNotifierUserTimings;}
	uint16  GetNotifierUserTimeToShow() {return prefs->notifierUserTimeToShow;}
	uint16  GetNotifierUserTimeToStay() {return prefs->notifierUserTimeToStay;}
	uint16  GetNotifierUserTimeToHide() {return prefs->notifierUserTimeToHide;}
	bool    GetNotifierLessFramerate() {return prefs->notifierLessFramerate;}
    bool    GetUseDownloadNotifier() {return prefs->useDownloadNotifier;}
	bool	GetUseNewDownloadNotifier(){return prefs->useNewDownloadNotifier;}
    bool    GetUseChatNotifier()	 {return prefs->useChatNotifier;}
    bool    GetUseLogNotifier()		 {return prefs->useLogNotifier;}
    bool    GetUseSoundInNotifier()  {return prefs->useSoundInNotifier;}
	bool    GetNotifierPopsEveryChatMsg() {return prefs->notifierPopsEveryChatMsg;}
	bool	GetNotifierPopOnImportantError()	{return prefs->notifierImportantError;}
	bool	GetNotifierPopOnSearch()			{return prefs->notifierSearchCompleted;}
    bool    GetNotifierAutoClose()              {return prefs->notifierAutoClose;};        
    bool    GetUseErrorNotifier()		{return prefs->useErrorNotifier;}      // added by InterCeptor (notify on error) 11.11.02
	bool	GetNotifierPopOnNewVersion()	{return prefs->notifierNewVersion;}
	char*   GetNotifierWavSoundPath() {return prefs->notifierSoundFilePath;}
	bool	GetNotifierNewPvtMsg() {return prefs->notifierNewPvtMsg;}//Rocks
	// [TPT] - enkeyDEV(th1) -notifier-
	

	CString	GetIRCNick()						{return (CString)prefs->m_sircnick;}
	void	SetIRCNick( char in_nick[] )		{strcpy(prefs->m_sircnick,in_nick);}
	CString	GetIRCServer()						{return (CString)prefs->m_sircserver;}
	bool	GetIRCAddTimestamp()				{return prefs->m_bircaddtimestamp;}
	CString	GetIRCChanNameFilter()				{return (CString)prefs->m_sircchannamefilter;}
	bool	GetIRCUseChanFilter()				{return prefs->m_bircusechanfilter;}
	uint16	GetIRCChannelUserFilter()			{return	prefs->m_iircchanneluserfilter;}
	CString	GetIrcPerformString()				{return (CString)prefs->m_sircperformstring;}
	bool	GetIrcUsePerform()					{return prefs->m_bircuseperform;}
	bool	GetIRCListOnConnect()				{return prefs->m_birclistonconnect;}
	bool	GetIrcAcceptLinks()					{return prefs->m_bircacceptlinks;}
	bool	GetIrcAcceptLinksFriends()			{return prefs->m_bircacceptlinksfriends;}
	bool	GetIrcIgnoreInfoMessage()			{return prefs->m_bircignoreinfomessage;}
	bool	GetIrcIgnoreEmuleProtoInfoMessage()	{return prefs->m_bircignoreemuleprotoinfomessage;}
	bool	GetIrcHelpChannel()					{return prefs->m_birchelpchannel;}
	WORD	GetWindowsVersion();
	bool	GetStartMinimized()					{return prefs->startMinimized;}
	void	SetStartMinimized( bool instartMinimized){prefs->startMinimized = instartMinimized;}

	bool	GetRestoreLastMainWndDlg()			{return prefs->m_bRestoreLastMainWndDlg;}
	int		GetLastMainWndDlgID()				{return prefs->m_iLastMainWndDlgID;}
	void	SetLastMainWndDlgID(int iID)		{prefs->m_iLastMainWndDlgID = iID;}

	bool	GetRestoreLastLogPane()				{return prefs->m_bRestoreLastLogPane;}
	int		GetLastLogPaneID()					{return prefs->m_iLastLogPaneID;}
	void	SetLastLogPaneID(int iID)			{prefs->m_iLastLogPaneID = iID;}

	bool	GetSmartIdCheck()					{return prefs->smartidcheck;}
	void	SetSmartIdCheck( bool in_smartidcheck){prefs->smartidcheck = in_smartidcheck;}
	uint8	GetSmartIdState()					{return prefs->smartidstate;}
	void	SetSmartIdState( uint8 in_smartidstate){prefs->smartidstate = in_smartidstate;}
	bool	GetVerbose()						{return prefs->m_bVerbose;}
	bool	GetQuickStart()				        {return prefs->m_QuickStart;} // [TPT] - quick start	
	bool	GetDebugSourceExchange()			{return prefs->m_bDebugSourceExchange;}
	bool	GetLogBannedClients()				{return prefs->m_bLogBannedClients;}
	bool	GetLogRatingReceived()				{return prefs->m_bLogRatingReceived;}
	bool	GetLogDescriptionReceived()			{return prefs->m_bLogDescriptionReceived;}
	bool	GetLogFilteredIPs()					{return prefs->m_bLogFilteredIPs;}
	void	SetLogFilteredIPs(bool flag)		{prefs->m_bLogFilteredIPs = flag;} // [TPT]
	bool	GetLogFileSaving()					{return prefs->m_bLogFileSaving;}
	int		GetDebugServerTCPLevel()			{return prefs->m_iDebugServerTCPLevel;}
	int		GetDebugServerUDPLevel() 			{return prefs->m_iDebugServerUDPLevel;}
	int		GetDebugServerSourcesLevel()		{return prefs->m_iDebugServerSourcesLevel;}
	int		GetDebugServerSearchesLevel()		{return prefs->m_iDebugServerSearchesLevel;}
	int		GetDebugClientTCPLevel()			{return prefs->m_iDebugClientTCPLevel;}
	int		GetDebugClientUDPLevel()			{return prefs->m_iDebugClientUDPLevel;}
	bool	GetPreviewPrio()					{return prefs->m_bpreviewprio;}
	void	SetPreviewPrio(bool in)				{prefs->m_bpreviewprio=in;}
	bool	GetUpdateQueueList()				{return prefs->m_bupdatequeuelist;}
	bool	GetManualHighPrio()					{return prefs->m_bmanualhighprio;}
	bool	TransferFullChunks()				{return prefs->m_btransferfullchunks;}
	void	SetTransferFullChunks( bool m_bintransferfullchunks )				{prefs->m_btransferfullchunks = m_bintransferfullchunks;}
	bool	StartNextFile()						{return prefs->m_bstartnextfile;}
	bool	ShowOverhead()						{return prefs->m_bshowoverhead;}
	void	SetNewAutoUp(bool m_bInUAP)			{prefs->m_bUAP = m_bInUAP;}
	bool	GetNewAutoUp()						{return prefs->m_bUAP;}
	void	SetNewAutoDown(bool m_bInDAP)		{prefs->m_bDAP = m_bInDAP;}
	bool	GetNewAutoDown()					{return prefs->m_bDAP;}
	bool	IsKnownClientListDisabled()			{return prefs->m_bDisableKnownClientList;}
	bool	IsQueueListDisabled()				{return prefs->m_bDisableQueueList;}
	bool	IsFirstStart()						{return prefs->m_bFirstStart;}
	
	

	char*	GetTxtEditor()						{return prefs->TxtEditor;}
	CString	GetVideoPlayer()					{if (strlen(prefs->VideoPlayer)==0) return ""; else return CString(prefs->VideoPlayer);}

	CString	GetUpdateURLIPFilter()				{return CString(prefs->UpdateURLIPFilter);}// [TPT] - Ipfilter Update MORPH START added by Yun.SF3: Ipfilter.dat update
	void	SetUpdateURLIPFilter(CString url)   {sprintf(prefs->UpdateURLIPFilter,"%s",url);} // [TPT] - Ipfilter Update


	uint32	GetFileBufferSize()					{return prefs->m_iFileBufferSize*15000;}
	uint32	GetQueueSize()						{return prefs->m_iQueueSize*100;}
	int		GetCommitFiles()					{return prefs->m_iCommitFiles;}

	// [TPT] - Ipfilter UpdateMORPH START added by Yun.SF3: Ipfilter.dat update
 
	uint32	GetIPfilterVersion()				{return prefs->m_IPfilterVersion;}
	void	SetIpfilterVersion(uint32 version)	{prefs->m_IPfilterVersion = version;}
	// [TPT] - Ipfilter Update MORPH END added by Yun.SF3: Ipfilter.dat update
	// Barry
	uint16	Get3DDepth() { return prefs->depth3D;}
	bool	AutoTakeED2KLinks() {return prefs->autotakeed2klinks;}
	bool	AddNewFilesPaused() {return prefs->addnewfilespaused;}

	bool	TransferlistRemainSortStyle()	{ return prefs->m_bTransflstRemain;}
	void	TransferlistRemainSortStyle(bool in)	{ prefs->m_bTransflstRemain=in;}

	void	SetStatsColor(int index,DWORD value) {prefs->statcolors[index]=value;}
	DWORD	GetStatsColor(int index) {return prefs->statcolors[index];}
	void	SetMaxConsPerFive(int in) {prefs->MaxConperFive=in;}
	LPLOGFONT GetHyperTextLogFont() { return &prefs->m_lfHyperText; }
	void	SetHyperTextFont(LPLOGFONT plf) { prefs->m_lfHyperText = *plf; }

	// [TPT] - quick start
	void	SetMaxCon(int in)         {prefs->maxconnections=in;} 
	uint16	GetMaxCon()		          {return prefs->maxconnections;}
	void	SetQuickStartMaxCon(int in) { prefs->m_QuickStartMaxCon = in; }
	uint16  GetQuickStartMaxCon()		{ return prefs->m_QuickStartMaxCon; }
	void    SetQuickStartMaxConPerFive (int in) { prefs->m_QuickStartMaxConPerFive = in; }
	uint16  GetQuickStartMaxConPerFive(){ return prefs->m_QuickStartMaxConPerFive; }
	// [TPT] - quick start

	uint16	GetMaxConperFive()					{return prefs->MaxConperFive;}
	uint16	GetDefaultMaxConperFive();

	void	ResetStatsColor(int index);
	bool	IsSafeServerConnectEnabled()		{return prefs->safeServerConnect;}
	void	SetSafeServerConnectEnabled(bool in){prefs->safeServerConnect=in;}
	bool	IsMoviePreviewBackup()				{return prefs->moviePreviewBackup;}
	int		GetPreviewSmallBlocks()				{return prefs->m_iPreviewSmallBlocks;}
	int		GetExtractMetaData() const			{return prefs->m_iExtractMetaData;}

	// itsonlyme: hostnameSource
	char*	GetYourHostname()	{return prefs->yourHostname;}
	void	SetYourHostname(CString in)	{sprintf(prefs->yourHostname,"%s",in);}
	// itsonlyme: hostnameSource
	bool	IsCheckDiskspaceEnabled()		{return prefs->checkDiskspace != 0;}	// SLUGFILLER: checkDiskspace
	UINT	GetMinFreeDiskSpace()			{return prefs->m_uMinFreeDiskSpace;}

	// [TPT]
	//void	SetMaxUpload(uint16 in) {  prefs->maxupload = (in) ? in : 0xffff; }
	//void	SetMaxDownload(uint16 in) {prefs->maxdownload=(in) ? in : 0xffff; }
	bool	IsInfiniteQueueEnabled()		{return prefs->infiniteQueue;}	// [TPT] - SLUGFILLER: infiniteQueue
	// [TPT] - SLUGFILLER: hideOS
	uint8	GetHideOvershares()		{return prefs->hideOS;}
	bool	IsSelectiveShareEnabled()	{return prefs->selectiveShare;}
	// [TPT] - SLUGFILLER: hideOS
	// [TPT] - itsonlyme: displayOptions START
	bool	ShowFileSystemIcon()	{return prefs->showFileSystemIcon;}
	bool	ShowLocalRating()		{return prefs->showLocalRating;}  // [TPT] - SLUGFILLER: showComments
	// [TPT] - itsonlyme: displayOptions END

	WINDOWPLACEMENT GetEmuleWindowPlacement() {return prefs->EmuleWindowPlacement; }
	void SetWindowLayout(WINDOWPLACEMENT in) {prefs->EmuleWindowPlacement=in; }

	CStringList shareddir_list;
	CStringList adresses_list;

	int8 AutoConnectStaticOnly()	{return prefs->autoconnectstaticonly;}	
	int8 GetUpdateDays()			{return prefs->versioncheckdays;}
	uint32 GetLastVC()				{return prefs->versioncheckLastAutomatic;}
	void   UpdateLastVC();
	int	GetIPFilterLevel()			{ return prefs->filterlevel;}
	CString GetMessageFilter()		{ return CString(prefs->messageFilter);}
	CString GetCommentFilter()		{ return CString(prefs->commentFilter);}
	CString GetFilenameCleanups()	{ return CString(prefs->filenameCleanups);}

	bool	ShowRatesOnTitle()		{ return prefs->showRatesInTitle;}
    char*   GetNotifierConfiguration()    {return prefs->notifierConfiguration;}; //<<-- enkeyDEV(kei-kun) -skinnable notifier-
    void    SetNotifierConfiguration(CString configFullPath) {sprintf(prefs->notifierConfiguration,configFullPath); } //<<-- enkeyDEV(kei-kun) -skinnable notifier-
	void	LoadCats();
	CString	GetDateTimeFormat()		{ return CString(prefs->datetimeformat);}
	CString GetDateTimeFormat4Log()	{ return CString(prefs->datetimeformat4log);}
	// Download Categories (Ornis)
	int		AddCat(Category_Struct* cat) { catMap.Add(cat); return catMap.GetCount()-1;}
	bool	MoveCat(UINT from, UINT to);
	void	RemoveCat(int index);
	int		GetCatCount()			{ return catMap.GetCount();}
	Category_Struct* GetCategory(int index) { if (index>=0 && index<catMap.GetCount()) return catMap.GetAt(index); else return NULL;}
	char*	GetCatPath(uint8 index)	{ return catMap.GetAt(index)->incomingpath;}
	DWORD	GetCatColor(uint8 index)	{ if (index>=0 && index<catMap.GetCount()) return catMap.GetAt(index)->color; else return 0;}

	bool	ShowRatingIndicator()	{ return prefs->indicateratings;}
	int		GetAllcatType()			{ return prefs->allcatType;}
	void	SetAllcatType(int in)   { prefs->allcatType=in; }

	bool	WatchClipboard4ED2KLinks()	{ return prefs->watchclipboard;}
	bool	GetRemoveToBin()			{ return prefs->m_bRemove2bin;}
	bool	FilterServerByIP()		{ return prefs->filterserverbyip;}

	bool	Log2Disk()	{ return prefs->log2disk;}
	bool	Debug2Disk()	{ return prefs->debug2disk;}
	int		GetMaxLogBuff() { return prefs->iMaxLogBuff;}
	UINT	GetMaxLogFileSize() { return prefs->uMaxLogFileSize; }
	// [TPT] - itsonlyme: virtualDirs
	CRBMap<CString, CString> *GetFileToVDirMap() { return &m_fileToVDir_map; }
	CRBMap<CString, CString> *GetDirToVDirMap() { return &m_dirToVDir_map; }
	CRBMap<CString, CString> *GetSubDirToVDirMap() { return &m_dirToVDirWithSD_map; }
	// [TPT] - itsonlyme: virtualDirs

	// WebServer
	uint16	GetWSPort()								{ return prefs->m_nWebPort; }
	void	SetWSPort(uint16 uPort)					{ prefs->m_nWebPort=uPort; }
	CString	GetWSPass()								{ return CString(prefs->m_sWebPassword); }
	void	SetWSPass(CString strNewPass);
	bool	GetWSIsEnabled()						{ return prefs->m_bWebEnabled; }
	void	SetWSIsEnabled(bool bEnable)			{ prefs->m_bWebEnabled=bEnable; }
	bool	GetWebUseGzip()							{ return prefs->m_bWebUseGzip; }
	void	SetWebUseGzip(bool bUse)				{ prefs->m_bWebUseGzip=bUse; }
	int		GetWebPageRefresh()						{ return prefs->m_nWebPageRefresh; }
	void	SetWebPageRefresh(int nRefresh)			{ prefs->m_nWebPageRefresh=nRefresh; }
	bool	GetWSIsLowUserEnabled()					{ return prefs->m_bWebLowEnabled; }
	void	SetWSIsLowUserEnabled(bool in)			{ prefs->m_bWebLowEnabled=in; }
	CString	GetWSLowPass()							{ return CString(prefs->m_sWebLowPassword); }
	void	SetWSLowPass(CString strNewPass);

	void	SetMaxSourcesPerFile(uint16 in)			{ prefs->maxsourceperfile=in;}
	void	SetMaxConnections(uint16 in)			{ prefs->maxconnections =in;}
	bool	IsSchedulerEnabled()					{ return prefs->scheduler;}
	void	SetSchedulerEnabled(bool in)			{ prefs->scheduler=in;}
	bool	GetDontCompressAvi()					{ return prefs->dontcompressavi;}
	
	bool	MsgOnlyFriends()						{ return prefs->msgonlyfriends;}
	bool	MsgOnlySecure()							{ return prefs->msgsecure;}
	uint16	GetMsgSessionsMax()						{ return prefs->maxmsgsessions;}
	bool	IsSecureIdentEnabled()					{ return prefs->m_bUseSecureIdent;} // use clientcredits->CryptoAvailable() to check if crypting is really available and not this function
	bool	IsAdvSpamfilterEnabled()				{ return prefs->m_bAdvancedSpamfilter;}
	CString	GetTemplate()							{ return CString(prefs->m_sTemplateFile);}
	void	SetTemplate(CString in)					{ sprintf(prefs->m_sTemplateFile,"%s",in);}
	bool	GetNetworkKademlia()					{ return prefs->networkkademlia;}
	void	SetNetworkKademlia(bool val)			{ prefs->networkkademlia = val;}
	bool	GetNetworkED2K()						{ return prefs->networked2k;}
	void	SetNetworkED2K(bool val)				{ prefs->networked2k = val;}

	// mobileMule
	CString	GetMMPass()								{ return CString(prefs->m_sMMPassword); }
	void	SetMMPass(CString strNewPass);
	bool	IsMMServerEnabled()						{ return prefs->m_bMMEnabled; }
	void	SetMMIsEnabled(bool bEnable)			{ prefs->m_bMMEnabled=bEnable; }
	uint16	GetMMPort()								{ return prefs->m_nMMPort; }
	void	SetMMPort(uint16 uPort)					{ prefs->m_nMMPort=uPort; }

	// deadlake PROXYSUPPORT
	const ProxySettings& GetProxy()								{return prefs->proxy;}
	void SetProxySettings(const ProxySettings& proxysettings)	{prefs->proxy = proxysettings;}
	uint16	GetListenPort()				{if (m_UseProxyListenPort) return ListenPort; else return prefs->port;}
	void	SetListenPort(uint16 uPort)	{ListenPort = uPort; m_UseProxyListenPort = true;}
	void	ResetListenPort()			{ListenPort = 0; m_UseProxyListenPort = false;}
	void	SetUseProxy(bool in)		{ prefs->proxy.UseProxy=in;}
	bool	GetShowProxyErrors()		{ return prefs->m_bShowProxyErrors; }
	void	SetShowProxyErrors(bool bEnable){ prefs->m_bShowProxyErrors = bEnable; }

	bool	IsProxyASCWOP()				{ return prefs->m_bIsASCWOP;}
	void	SetProxyASCWOP(bool in)		{ prefs->m_bIsASCWOP=in;}

	bool	ShowCatTabInfos()			{ return prefs->showCatTabInfos;}
	void	ShowCatTabInfos(bool in)	{ prefs->showCatTabInfos=in;}

	bool	AutoFilenameCleanup()			{ return prefs->autofilenamecleanup;}
	void	AutoFilenameCleanup(bool in)	{ prefs->autofilenamecleanup=in;}
	void	SetFilenameCleanups(CString in) { sprintf(prefs->filenameCleanups,"%s",in);}

	bool	GetResumeSameCat()			{ return prefs->resumeSameCat;}
	bool	IsGraphRecreateDisabled()	{ return prefs->dontRecreateGraphs;}
	bool	IsExtControlsEnabled()		{ return prefs->m_bExtControls;}
	void	SetExtControls(bool in)		{ prefs->m_bExtControls=in;}
	bool	GetRemoveFinishedDownloads(){ return prefs->m_bRemoveFinishedDownloads;}

	uint16	GetMaxChatHistoryLines()	{ return prefs->m_iMaxChatHistory;}
	bool	GetUseAutocompletion()		{ return prefs->m_bUseAutocompl;}
	bool	GetUseDwlPercentage()		{ return prefs->m_bShowDwlPercentage;}
	void	SetUseDwlPercentage(bool in){ prefs->m_bShowDwlPercentage=in;}

	//Toolbar
	CString GetToolbarSettings() 						{ return prefs->m_sToolbarSettings; }
	void	SetToolbarSettings(CString in) 				{ sprintf(prefs->m_sToolbarSettings,in);}
	CString GetToolbarBitmapSettings() 					{ return prefs->m_sToolbarBitmap; }
	void	SetToolbarBitmapSettings(CString path)		{ sprintf(prefs->m_sToolbarBitmap,path);}
	CString GetToolbarBitmapFolderSettings() 			{ return prefs->m_sToolbarBitmapFolder; }
	void	SetToolbarBitmapFolderSettings(CString path){ sprintf(prefs->m_sToolbarBitmapFolder,path); }
	int8	GetToolbarLabelSettings()					{ return prefs->m_nToolbarLabels; }
	void	SetToolbarLabelSettings(int8 settings)		{ prefs->m_nToolbarLabels= settings; }

	//preview
	bool	IsPreviewEnabled()			{ return true; }
	void	SetPreview(bool in)			{ prefs->m_bPreviewEnabled = in; }

	int		GetSearchMethod() const		{ return prefs->m_iSearchMethod; }
	void	SetSearchMethod(int iMethod){ prefs->m_iSearchMethod = iMethod; }
	
	// ZZ:UploadSpeedSense -->
    /*bool    IsDynUpEnabled() { return prefs->m_bDynUpEnabled; }
    void    SetDynUpEnabled(bool newValue) { prefs->m_bDynUpEnabled = newValue; }
    int     GetDynUpPingTolerance() { return prefs->m_iDynUpPingTolerance; }
    int     GetDynUpGoingUpDivider() { return prefs->m_iDynUpGoingUpDivider; }
    int     GetDynUpGoingDownDivider() { return prefs->m_iDynUpGoingDownDivider; }
    int     GetDynUpNumberOfPings() { return prefs->m_iDynUpNumberOfPings; }*/
	// ZZ:UploadSpeedSense <--
	
	// [TPT] - khaos::categorymod+	
	bool	ShowCatNameInDownList()	{ return prefs->m_bShowCatNames; }
	bool	SelectCatForNewDL()		{ return prefs->m_bSelCatOnAdd; }
	bool	UseActiveCatForLinks()	{ return prefs->m_bActiveCatDefault; }
	bool	AutoSetResumeOrder()	{ return prefs->m_bAutoSetResumeOrder; }	
	uint8	StartDLInEmptyCats()	{ return prefs->m_iStartDLInEmptyCats; } // 0 = disabled, otherwise num to resume
	bool	UseAutoCat()			{ return prefs->m_bUseAutoCat; }
	void    DownloadNextInThisCat()  { prefs->m_bActiveCatDefault = true; 
									   prefs->m_bSelCatOnAdd = false;} // [TPT]: [TPT] - khaos::categorymod
	// [TPT] - khaos::categorymod-

	//eWombat [SNAFU][TPT]
	bool GetAntiSnafu()	{ return prefs->m_bSnafu; };
	bool GetAntiCreditTheft()	{ return prefs->m_bAntiCreditTheft; };
	bool GetAntiFriendshare() { return prefs->m_bAntiFriendshare; };

	// [TPT] - TBH: minimule
	bool	IsMiniMuleEnabled() { return prefs->m_bMiniMule;}
	void	SetMiniMuleEnabled(bool in) {prefs->m_bMiniMule = in; }
	uint32	GetMiniMuleUpdate()	{return prefs->m_iMiniMuleUpdate;}
	void	SetMiniMuleUpdate(uint32 in)  {prefs->m_iMiniMuleUpdate = in;}
	void	SetMiniMuleLives(bool in) {prefs->m_bMiniMuleLives = in; }
	bool	GetMiniMuleLives()	{ return prefs->m_bMiniMuleLives;}
	void	SetMiniMuleTransparency(int8 in) { prefs->m_iMiniMuleTransparency = in; }
	int8	GetMiniMuleTransparency() { return prefs->m_iMiniMuleTransparency; }
	// [TPT] - TBH: minimule
protected:
	void	CreateUserHash();
	void	SetStandartValues();
	static int GetRecommendedMaxConnections();

// [TPT] - Select process priority 
public:
	const DWORD GetMainProcessPriority() const { return m_MainProcessPriority; }	
// [TPT] - Select process priority 

private:
	CString appdir;
	CString configdir;
	CString ed2klinkdir; // [TPT] - Save ed2klinks
	CString m_strWebServerDir;
	CString m_strLangDir;
	Preferences_Struct* prefs;
	Preferences_Ext_Struct* prefsExt;

	// [TPT]
	//Preferences_Import19c_Struct* prefsImport19c;
	//Preferences_Import20a_Struct* prefsImport20a;
	//Preferences_Import20b_Struct* prefsImport20b;
	
	char userhash[16];
	WORD m_wWinVer;

	void LoadPreferences();
	void SavePreferences();

	CArray<Category_Struct*,Category_Struct*> catMap;
	// [TPT] - itsonlyme: virtualDirs
	CRBMap<CString, CString>	m_fileToVDir_map;
	CRBMap<CString, CString>	m_dirToVDir_map;
	CRBMap<CString, CString>	m_dirToVDirWithSD_map;
	// [TPT] - itsonlyme: virtualDirs

	// deadlake PROXYSUPPORT
	bool m_UseProxyListenPort;
	uint16	ListenPort;
	
	uint32	m_MainProcessPriority;	// [TPT] - Select process priority 

public:
	//[TPT]-Cumulate Bandwidth
	bool	IsCumulateBandwidthEnabled() {return prefs->cumulateBandwidth;}// Cumulate Bandwidth
	void	SetCumulateBandwidth(float in)	{prefs->cumulateBandwidth = in;}// Cumulate Bandwidth
	// added by [TPT]-MoNKi [MoNKi: -invisible mode-]
	bool GetInvisibleMode() { return prefs->m_bInvisibleMode; }
	UINT GetInvisibleModeHKKeyModifier() const { return prefs->m_iInvisibleModeHotKeyModifier; }
	char GetInvisibleModeHKKey() { return prefs->m_cInvisibleModeHotKey; }
	void SetInvisibleMode(bool on, UINT keymodifier, char key);
	// End [TPT]-MoNKi 
	// Added by [TPT]-MoNKi [MoNKi: -Downloaded History-]
public:
	bool	GetShowSharedInHistory()		{ return prefs->m_bHistoryShowShared; }
	void	SetShowSharedInHistory(bool on)	{ prefs->m_bHistoryShowShared = on; }
	// End MoNKi

	// [TPT] - MoNKi: -Support for High Contrast Mode-
public:
	bool	WindowsTextColorOnHighContrast() { return prefs->m_bUseWindowsTextColorOnHighContrast; }
	void	SetWindowsTextColorOnHighContrast(bool on) { prefs->m_bUseWindowsTextColorOnHighContrast = on; }
	// [TPT] - MoNKi: -Support for High Contrast Mode-
	// [TPT] - TBH: minimule
	int	GetSpeedMeterMin()		{return prefs->speedmetermin;}
	int	GetSpeedMeterMax()		{return prefs->speedmetermax;}
	void	SetSpeedMeterMin(int in)	{prefs->speedmetermin = in;}
	void	SetSpeedMeterMax(int in) {prefs->speedmetermax = in;}
	// [TPT] - TBH: minimule
};
